#include "mode_switcher.h"
#include "test_mode.h"


ModeSwitcher::ModeSwitcher()
{
	static TestMode test_mode;

	_modes.push_back( &test_mode );
}


void ModeSwitcher::short_press()
{
	_modes[ _mode ]->next_flavour();
}


void ModeSwitcher::long_press()
{
	if( ++_mode >= (signed)_modes.size() )
		_mode = 0;
	_modes[ _mode ]->activate();
}


void ModeSwitcher::activate()
{
	_mode = 0;
	_modes[ _mode ]->activate();
}


Drawer &ModeSwitcher::get_drawer()
{
	return *_modes[ _mode ];
}
