#include "major_mode.h"
#include <vector>


class MinorMode;
class Drawer;


class ModeSwitcher
    :
    public MajorMode
{
public:

	ModeSwitcher();

	/**
	 * Called to inform the major mode that there has been a short press.
	 */
	void short_press();

	/**
	 * Called to inform the major mode that there has been a long press.
	 */
	void long_press();

	/**
	 * Called when this major mode is becoming active
	 */
	void activate();

	/**
	 * Retrieve a drawer.
	 *
	 * @return drawer
	 */
	Drawer &get_drawer();

private:

	/* minor modes that this mode switcher switches */
	std::vector< MinorMode * > _modes;

	/* current mode */
	int _mode;

};
