class Time
{
public:

	/**
	 * Get singleton instance.
	 *
	 * @return instance
	 */
	static Time &get_instance();

	/**
	 * Get hours.
	 *
	 * @return hours, 0 to 23
	 */
	int get_hours();

	/**
	 * Get minutes.
	 *
	 * @return minutes, 0 to 59
	 */
	int get_minutes();

	/**
	 * Get seconds.
	 *
	 * @return seconds, 0 to 59
	 */
	int get_seconds();

	/**
	 * Update the time.
	 */
	void update();

protected:

	Time();

	/** hours */
	int _hours;

	/** minutes */
	int _minutes;

	/** seconds */
	int _seconds;

private:

	/** milliseconds at last update */
	unsigned long _last_millis;

	/** milliseconds carries over from last update */
	unsigned long _carry;

};
